.386
.model flat, stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     invoke.inc

LoadEXEfromMem  PROTO :DWORD,:DWORD
FreeEXEfromMem  PROTO :DWORD
GetProcAddr     PROTO :DWORD,:DWORD

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  ..\..\lib\PEmem.lib

EXTERN pDLL:PTR BYTE                            ; pointer to ConsoleOut.dll linked together with
                                                ; the main executable

.data

DLLfunc1    db 'ClearScreen',0  ; ClearScreen function from ConsFuncs.dll
DLLfunc2    db 'StdOut',0       ; StdOut function from ConsFuncs.dll

message     db 'StdOut function - DLL in memory test',0
errmessage1 db 'could not load the DLL',0
errmessage2 db 'GetProcAddr cannot find the address',13,10
            db 'of the requested function',0
caption     db 'Error',0

.data?

hVirtModule dd ?                                 ; handle to the "virtual" module ConsFuncs.dll
pEntry      dd ?

.code

start:

    invoke  LoadEXEfromMem,ADDR pDLL,ADDR pEntry
    test    eax,eax
    jnz     @f
    invoke  MessageBox,0,ADDR errmessage1,ADDR caption,MB_ICONERROR
    jmp     finish2                          
@@:
    mov     hVirtModule,eax

; GetProcAddr gets the address of ClearScreen from the "virtual" ConsFuncs.dll

    invoke  GetProcAddr,eax,ADDR DLLfunc1
    cmp     eax,-1
    jne     @f
    invoke  MessageBox,0,ADDR errmessage2,ADDR caption,MB_ICONERROR
    jmp     finish1

@@:

; eax -> address of ClearScreen

    _invoke eax

; GetProcAddr gets the address of StdOut from the "virtual" ConsFuncs.dll

    invoke  GetProcAddr,hVirtModule,ADDR DLLfunc2
    cmp     eax,-1
    jne     @f
    invoke  MessageBox,0,ADDR errmessage2,ADDR caption,MB_ICONERROR
    jmp     finish1
@@:

; eax -> address of StdOut taking one parameter

    _invoke eax,ADDR message
       
finish1:

; Release the "virtual" DLL

    invoke  FreeEXEfromMem,hVirtModule

finish2:

    invoke  ExitProcess,0

END start
