.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data

Resource      db 0,8,202,16,0,0,0,0,2,0,200,0,200,0,186,0
              db 94,0,0,0,0,0,80,0,69,0,32,0,105,0,110,0
              db 32,0,109,0,101,0,109,0,111,0,114,0,121,0,0,0
              db 0,0,1,80,0,0,0,0,64,0,12,0,50,0,21,0
              db 110,0,255,255,128,0,38,0,83,0,97,0,121,0,32,0
              db 72,0,101,0,108,0,108,0,111,0,0,0,0,0,0,0
              db 0,0,1,80,0,0,0,0,64,0,42,0,50,0,21,0
              db 120,0,255,255,128,0,38,0,69,0,120,0,105,0,116,0
              db 0,0,0,0,0,0,0,0,144,0,38,0,70,0,105,0
              db 108,0,101,0,0,0,0,0,11,0,38,0,83,0,97,0
              db 121,0,32,0,104,0,101,0,108,0,108,0,111,0,0,0
              db 128,0,12,0,38,0,69,0,120,0,105,0,116,0,0,0

msg           db 'Dialog box with menu',0
title1        db 'Hello!',0

IDM_HELLO     equ 11
IDM_EXIT      equ 12
IDC_HELLO     equ 110
IDC_EXIT      equ 120
IDC_EDIT      equ 3000

MENU_TEMPLATE equ 084h

.code

start:

    invoke    GetModuleHandle,0
    invoke    DialogBoxIndirectParam,eax,ADDR Resource,NULL,ADDR DlgProc,NULL

    ret       ; Use ret instead of ExitProcess to return to the main executable
              ; hosting Dialog.exe

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    .IF uMsg==WM_INITDIALOG

        invoke  LoadIcon,NULL,IDI_APPLICATION    
        invoke  SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
        lea     eax,[Resource+MENU_TEMPLATE]
        invoke  LoadMenuIndirect,eax
        invoke  SetMenu,hWnd,eax
        
    .ELSEIF uMsg==WM_CLOSE

        invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

    .ELSEIF uMsg==WM_COMMAND
        
        mov eax,wParam
        .IF lParam==0
            .IF ax==IDM_HELLO
                invoke MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
            .ELSEIF ax==IDM_EXIT
                                @@:
                invoke EndDialog,hWnd,0
            .ENDIF
        .ELSE
            mov edx,wParam
            shr edx,16
            .IF dx==BN_CLICKED
                .IF ax==IDC_HELLO
                    invoke SendMessage,hWnd,WM_COMMAND,IDM_HELLO,0
                .ELSEIF ax==IDC_EXIT
                    jmp @b
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        mov eax,FALSE
        ret
    .ENDIF
    mov eax,TRUE
    ret
DlgProc ENDP

END start
