.386
.model flat, stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc

LoadEXEfromMem  PROTO :DWORD,:DWORD
FreeEXEfromMem  PROTO :DWORD
GetProcAddr     PROTO :DWORD,:DWORD

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  ..\..\lib\PEmem.lib

EXTERN      pEXE:PTR BYTE                       ; pointer to Dialog.exe linked together
                                                ; with the main executable

.data

message1    db 'Ready to test PE in memory...',0
message2    db 'Testing finished.',0
title1      db 'Portable executable in memory',0
errmessage  db 'could not load the PE',0
caption     db 'Error',0

.data?

hVirtModule	dd ?                                ; handle to the "virtual" module Dialog.exe
pEntry      dd ?

.code

start:

    invoke  MessageBox,0,ADDR message1,ADDR title1,MB_OK
    invoke  LoadEXEfromMem,ADDR pEXE,ADDR pEntry
    test    eax,eax
    jnz     @f
    invoke  MessageBox,0,ADDR errmessage,ADDR caption,MB_ICONERROR
    jmp     finish
@@:
    mov     hVirtModule,eax

; call the executable embedded in our main executable PEmem

    call    pEntry
    invoke  MessageBox,0,ADDR message2,ADDR title1,MB_OK

; release the memory allocated for the virtual executable

    invoke  FreeEXEfromMem,hVirtModule

finish:

    invoke	ExitProcess,0

END start
