.386
.model flat,stdcall
option casemap:none

.code

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

ALIGN 4

_BinSearch PROC USES esi edi ebx StringTable:DWORD,NumbOfElements:DWORD,ElementToFind:DWORD,hModule:DWORD

; StringTable    -> Address of the string array
; NumbOfElements -> Number of items in the array
; ElementToFind  -> Item to search for
; The function returns the ZERO based index of ElementToFind.
;                      -1 if ElementToFind is not a member of the array
; hModule        -> Handle to the DLL module

; LOCAL max:DWORD
; LOCAL _zero:DWORD                 ; dummy variable
; LOCAL min:DWORD

    add     esp,-3*4                ; allocate space on the stack for the local variables
    push    esi
    push    edi
    push    ebx
    push    ebp

    xor     esi,esi
    lea     ebp,[esp+5*4]           ; OFFSET _zero
    mov     edi,DWORD PTR [esp+9*4] ; NumbOfElements
    mov     DWORD PTR [ebp+4],esi
    sub     edi,1
    mov     ebx,DWORD PTR [esp+8*4] ; StringTable
    mov     DWORD PTR [ebp-4],edi
@@:
    cmp     esi,edi
    jbe     l0
    mov     eax,-1                  ; if the element is not found 
    pop     ebp                     ; then return -1
    pop     ebx
    pop     edi
    pop     esi
    add     esp,3*4
    ret     4*4
l0:
    mov     edx,esi
    add     edx,edi
    shr     edx,1
    push    edx
    lea     eax,[ebx+4*edx]
    mov     edx,DWORD PTR [eax]      ; Middle value
    add     edx,DWORD PTR [esp+12*4] ; add hModule
    mov     ecx,DWORD PTR [esp+11*4] ; ElementToFind
    push    ebx

; strcmpX PROC ElementToFind:DWORD,MiddleValue:DWORD

    mov     ebx,-1
_loop:
    add     ebx,1
    movzx   eax,BYTE PTR [ecx+ebx]
    test    eax,eax
    jz      l1
    cmp     al,BYTE PTR [edx+ebx]
    je      _loop
    sbb     eax,eax
    sbb     eax,-1

; strcmpX ENDP

l1:
    pop     ebx
    pop     edx

    test    eax,eax
    jz      l2                      ; one conditinal jump here
    
    lea     ecx,[ebp+4*eax]         ; modify min and max
    add     edx,eax
    mov     DWORD PTR [ecx],edx
    mov     esi,DWORD PTR [ebp+4]   ; min
    mov     edi,DWORD PTR [ebp-4]   ; max
    jmp     @b
l2:
    mov     eax,edx                 ; eax -> ZERO based index value
    pop     ebp
    pop     ebx
    pop     edi
    pop     esi
    add     esp,3*4                 ; balance the stack
    ret     4*4

_BinSearch ENDP

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

END

